#include <stdio.h>
#include <string.h>

#define MAX_LINE_LEN 512
#define MAX_TOK_LEN  30
#define MAX_DEF_LEN  30

int main (int argc, char ** argv)
{
  FILE *in, *out;
  char line [MAX_LINE_LEN], token [MAX_TOK_LEN], def [MAX_DEF_LEN];
  int output = 1, ifdef_debug = 0;

  in = stdin;
  out = stdout;

  if (argc > 1)
    if ((in = fopen (argv [1], "r")) == NULL) {
      fprintf (stderr, "Cannot open %s.\n", argv [1]);
      exit (1);
    }

  if (argc > 2)
    if ((out = fopen (argv [2], "w")) == NULL) {
      fprintf (stderr, "Cannot create %s.\n", argv[2]);
      exit (1);
    }

  while (!feof (in)) {
    fgets (line, MAX_LINE_LEN, in);
    sscanf (line, "%s%s", token, def);
    if (!strcmp (token, "#ifdef"))
      if (!strcmp (def, "DEBUG")) {
	output = 0;
	ifdef_debug = 1;
      }
      else
	ifdef_debug = 0;

    if (!strcmp (token, "#else"))
      if (ifdef_debug)
	output = 1;

    if (output && !feof (in))
      fputs (line, out);

    if (!strcmp (token, "#endif"))
      if (ifdef_debug) {
	output = 1;
	ifdef_debug = 0;
      }
  }

  return 0;
}
